package de.intevation.flys.artifacts.access;

import de.intevation.flys.artifacts.FLYSArtifact;

import java.util.Arrays;

import org.apache.log4j.Logger;

public class FixAccess
extends      RiverAccess
{
    private static Logger log = Logger.getLogger(FixAccess.class);

    protected Double from;
    protected Double to;
    protected Double step;

    protected Long start;
    protected Long end;

    protected Integer qSectorStart;
    protected Integer qSectorEnd;

    protected int [] events;

    protected Boolean preprocessing;

    protected String  function;

    public FixAccess() {
    }

    public FixAccess(FLYSArtifact artifact) {
        super(artifact);
    }

    public Double getFrom() {

        if (from == null) {
            from = getDouble("from");
        }

        if (log.isDebugEnabled()) {
            log.debug("from: '" + from + "'");
        }

        return from;
    }

    public Double getTo() {

        if (to == null) {
            to = getDouble("to");
        }

        if (log.isDebugEnabled()) {
            log.debug("to: '" + to + "'");
        }

        return to;
    }

    public Double getStep() {

        if (step == null) {
            step = getDouble("step");
        }

        if (log.isDebugEnabled()) {
            log.debug("step: '" + step + "'");
        }

        return step;
    }

    public Long getStart() {

        if (start == null) {
            start = getLong("start");
        }

        if (log.isDebugEnabled()) {
            log.debug("start: '" + start + "'");
        }

        return start;
    }

    public Long getEnd() {

        if (end == null) {
            end = getLong("end");
        }

        if (log.isDebugEnabled()) {
            log.debug("end: '" + end + "'");
        }

        return end;
    }

    public Integer getQSectorStart() {

        if (qSectorStart == null) {
            qSectorStart = getInteger("q1");
        }

        if (log.isDebugEnabled()) {
            log.debug("q1: '" + qSectorStart + "'");
        }

        return qSectorStart;
    }

    public Integer getQSectorEnd() {

        if (qSectorEnd == null) {
            qSectorEnd = getInteger("q2");
        }

        if (log.isDebugEnabled()) {
            log.debug("q2: '" + qSectorEnd + "'");
        }

        return qSectorEnd;
    }

    public int [] getEvents() {
        if (events == null) {
            events = getIntArray("events");
        }
        if (log.isDebugEnabled() && events != null) {
            log.debug("events: " + Arrays.toString(events));
        }
        return events;
    }

    public Boolean getPreprocessing() {
        if (preprocessing == null) {
            preprocessing = getBoolean("preprocessing");
        }
        if (log.isDebugEnabled()) {
            log.debug("preprocessing: " + preprocessing);
        }
        return preprocessing;
    }

    public String getFunction() {
        if (function == null) {
            function = getString("function");
        }
        if (log.isDebugEnabled()) {
            log.debug("function: " + function);
        }
        return function;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
